package org.example.mislugares;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends FragmentActivity implements LocationListener { // 8_8
	private TextView showSms;																				// ListActivity
	private String proveedor;																				// implements
	private VistaLugarFragment fragmentVista; // 8-8
	private LocationManager manejador;
	private Location mejorLocaliz;
	private static final long DOS_MINUTOS = 2 * 60 * 1000;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		Lugares.indicializaBD(this);
		// Toast.makeText(this, "Se cargaron los datos ", Toast.LENGTH_SHORT)
		// .show();
		VistaLugarFragment fragmentVista = (VistaLugarFragment) getSupportFragmentManager()
				.findFragmentById(R.id.vista_lugar_fragment);
		if (fragmentVista != null) {
			fragmentVista.actualizarVistas(Lugares.primerId());

		/*SelectorFragment SelectF = (SelectorFragment) getSupportFragmentManager()
				.findFragmentById(R.id.selector_fragment);
		if (SelectF != null) {
			SelectF.getId();*/

			// 8-8 eliminado vista_lugar_fragment
			}

			
			manejador = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
			if (manejador.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
				actualizaMejorLocaliz(manejador
						.getLastKnownLocation(LocationManager.GPS_PROVIDER));
			}
			if (manejador.isProviderEnabled(LocationManager.NETWORK_PROVIDER)) {
				actualizaMejorLocaliz(manejador
						.getLastKnownLocation(LocationManager.NETWORK_PROVIDER));
			}
			Criteria criterio = new Criteria();
			criterio.setCostAllowed(false);
			criterio.setAltitudeRequired(false);
			criterio.setAccuracy(Criteria.ACCURACY_FINE);

			proveedor = manejador.getBestProvider(criterio, true);
			Location localiz = manejador.getLastKnownLocation(proveedor);

			}
	

	private void actualizaMejorLocaliz(Location localiz) {

		/*
		 * try { BD_Respaldo(); //llamado al metodo } catch (IOException e) { //
		 * TODO Auto-generated catch block e.printStackTrace(); }
		 */

		if (localiz != null) { // aporte de un colega Javier Beteta LLuna
			if (mejorLocaliz == null
					|| localiz.getAccuracy() < 2 * mejorLocaliz.getAccuracy()
					|| localiz.getTime() - mejorLocaliz.getTime() > DOS_MINUTOS) {
				Log.d(Lugares.TAG, "Nueva mejor localizacin");

				mejorLocaliz = localiz;
				Lugares.posicionActual.setLatitud(mejorLocaliz.getLatitude());
				Lugares.posicionActual.setLongitud(mejorLocaliz.getLongitude());
				
			}/*
			 posicion = new GeoPunto(Lugares.posicionActual.getLatitud(),
			Lugares.posicionActual.getLongitud());
	tipo = TipoLugar.OTROS;
	 
	 *public double getLatitud() {
		// TODO Auto-generated method stub
		return GeoPunto.getLatitud();
		
		public double getLongitud() {
		// TODO Auto-generated method stub
		return GeoPunto.getLongitud();
	 */
		}
	}

	@Override
	public void onLocationChanged(Location location) {
		Log.d(Lugares.TAG, "Nueva localizacin: " + location);
		actualizaMejorLocaliz(location);
		showSms = (TextView) findViewById(R.id.textView4);
		showSms.setText(Lugares.posicionActual.toString());
	}

	@Override
	public void onProviderDisabled(String proveedor) {
		Log.d(Lugares.TAG, "Se deshabilita: " + proveedor);
		activarProveedores();
	}

	@Override
	public void onProviderEnabled(String proveedor) {
		Log.d(Lugares.TAG, "Se habilita: " + proveedor);
		activarProveedores();
	}

	@Override
	public void onStatusChanged(String proveedor, int estado, Bundle extras) {
		Log.d(Lugares.TAG, "Cambia estado: " + proveedor);
		activarProveedores();
	}

	@Override
	protected void onResume() {
		super.onResume();
		activarProveedores();

		// null pointer exception

	}

	private void activarProveedores() {
		if (manejador != null) {
			if (manejador.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
				Log.d(Lugares.TAG, "si hay provedor: " + manejador);
				manejador.requestLocationUpdates(LocationManager.GPS_PROVIDER,
						20 * 1000, 5, this);
			}
			Log.d(Lugares.TAG, "no hay provedor: " + manejador);

			if (manejador.isProviderEnabled(LocationManager.NETWORK_PROVIDER)) {
				manejador.requestLocationUpdates(
						LocationManager.NETWORK_PROVIDER, 10 * 1000, 10, this);
			}
		}

	}

	@Override
	protected void onPause() {
		super.onPause();
		if (manejador != null) {
			manejador.removeUpdates(this);
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);// agregado 8-8 copia
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	public void lanzarAcercaDe(View v) {
		Intent i = new Intent(this, AcercaDe.class);
		startActivity(i);
	}

	public void lanzarVistaLugar(View view) {
		final EditText entrada = new EditText(this);
		// i.putExtra("id", (long)0);
		entrada.setText("0");
		new AlertDialog.Builder(this).setTitle("Seleccin de lugar")
				.setMessage("indica su id:").setView(entrada)
				.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int whichButton) {
						long id = Long.parseLong(entrada.getText().toString());
						Intent i = new Intent(MainActivity.this,
								VistaLugar.class);// cambio 8.8 VistaLugar
						i.putExtra("id", id);
						startActivity(i);
					}
				})

				.setNegativeButton("Cancelar", null).show();
	}

	/**
	 * protected void onListItemClick(ListView listView, View vista, int
	 * posicion, long id) { super.onListItemClick(listView, vista, posicion,
	 * id); Intent intent = new Intent(this, VistaLugar.class);
	 * intent.putExtra("id", id); startActivity(intent); }
	 **/
	public void lanzarPreferencias(View view) {
		Intent i = new Intent(this, Preferencias.class);
		startActivity(i);
	}

	public void mostrarPreferencias(View view) {
		// creando el objeto pref de la clase SharedPreferences y
		// asigna las preferencias definidas para la aplicacin
		SharedPreferences pref = PreferenceManager
				.getDefaultSharedPreferences(this);
		// crea el String s y le asigna los valores de dos de las preferencias.
		String s = "notificaciones: " + pref.getBoolean("notificaciones", true)
				+ ", distancia mnima: " + pref.getString("distancia", "?");
		/*
		 * mtodos pref.getBoolean() y pref.getString(), que disponen de dos
		 * parmetros: el valor de key que queremos buscar ("notificaciones" y
		 * "distancia") y el valor asignado por defecto en caso de no encontrar
		 * esta key.
		 */
		// se visualiza el resultado utilizando la clase Toast (contexto
		// (nuestra actividad),String a mostrar, tiempo que se estar mostrando
		// esta informacin.)
		Toast.makeText(this, s, Toast.LENGTH_LONG).show();
	}

	/**
	 * public void actualizaLista() { ListView listView = (ListView)
	 * findViewById(R.id.listView); AdaptadorCursorLugares adaptador =
	 * (AdaptadorCursorLugares) listView .getAdapter();
	 * adaptador.changeCursor(Lugares.listado()); }
	 **/
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {

		case R.id.menu_mapa:

			Intent i = new Intent(this, Mapa.class);
			startActivity(i);
			break;

		case R.id.acercaDe:
			lanzarAcercaDe(null);
			break;
		case R.id.config:
			lanzarPreferencias(null);
			break;

		case R.id.accion_nuevo:
			long id = Lugares.nuevo();
			Intent intent = new Intent(this, EdicionLugar.class);
			intent.putExtra("id", id);
			// startActivity(intent);// ojo cambiar activityForResult
			startActivityForResult(intent, 1234);
			break;

		case R.id.menu_buscar:
			buscarLugar(null);
			break;

		}
		// return super.onContextItemSelected(item); // 8_8
		return super.onOptionsItemSelected(item);// ojo
		/** true -> consumimos el item, no se propaga */
	}

	@Override
	protected void onStart() {
		super.onStart();
		// Toast.makeText(this, "onStart", Toast.LENGTH_SHORT).show();
	}

	// @Override protected void onResume() {
	// super.onResume();
	// Toast.makeText(this, "onResume", Toast.LENGTH_SHORT).show(); }

	// @Override protected void onPause() {
	// Toast.makeText(this, "onPause", Toast.LENGTH_SHORT).show();
	// super.onPause(); //if (mp != null); //{mp.pause();}

	@Override
	protected void onStop() {
		super.onStop();
		// Toast.makeText(this, "onStop", Toast.LENGTH_SHORT).show();
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		// Toast.makeText(this, "onRestart", Toast.LENGTH_SHORT).show();
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		// Toast.makeText(this, "onDestroy", Toast.LENGTH_SHORT).show();
	}

	protected void onSaveInstanceState(Bundle estadoGuardado) {
		super.onSaveInstanceState(estadoGuardado);

		// if (mp != null) {

		// int pos = mp.getCurrentPosition();
		// estadoGuardado.putInt("posicion", pos);
		// }
	}

	@Override
	// 8-8
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		actualizarLista();
	}

	/**
	 * @Override //8-8 protected void onActivityResult(int requestCode, int
	 *           resultCode, Intent data) { super.onActivityResult(requestCode,
	 *           resultCode, data); actualizarLista(); }
	 **/
	public void actualizarLista() {
		ListView listView = (ListView) findViewById(R.id.listView);
		AdaptadorCursorLugares adaptador = (AdaptadorCursorLugares) listView
				.getAdapter();
		adaptador.changeCursor(Lugares.listado());

	}

	@Override
	protected void onRestoreInstanceState(Bundle estadoGuardado) {
		super.onRestoreInstanceState(estadoGuardado);
		// if (estadoGuardado != null && mp != null) {
		// int pos = estadoGuardado.getInt("posicion");
		// mp.seekTo(pos);
		// }
	}

	public void muestraLugar(long id) {// 8-8
		VistaLugarFragment fragmentVista = (VistaLugarFragment) getSupportFragmentManager()
				.findFragmentById(R.id.vista_lugar_fragment);
		if (fragmentVista != null) {
			fragmentVista.actualizarVistas(id);// error puntero nulo 8.8
		} else {
			Intent intent = new Intent(this, VistaLugar.class); // revision 0
			intent.putExtra("id", id);
			startActivityForResult(intent, 0);
		}
	}

	public void buscarLugar(View view) {
		final EditText entrada = new EditText(this);
		new AlertDialog.Builder(this)
				.setTitle("Buscar el lugar")
				.setMessage("indica parte de su nombre:")
				.setView(entrada)
				.setPositiveButton("Buscar",
						new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog,
									int whichButton) {
								String nombre = entrada.getText().toString();
								long id = Lugares.buscarParteNombre(nombre);
								if (id != -1) {
									muestraLugar(id);
								} else {
									Toast.makeText(getApplicationContext(),
											"Lugar no encontrado",
											Toast.LENGTH_LONG).show();
								}
							}
						}).setNegativeButton("Cancelar", null).show();
	}

	public static void BD_Respaldo() throws IOException { // aadido para copiar
															// db

		String stadoSD = Environment.getExternalStorageState();
		if (!stadoSD.equals(Environment.MEDIA_MOUNTED)
				|| stadoSD.equals(Environment.MEDIA_MOUNTED_READ_ONLY)) {
			// Toast.makeText(context,
			// "No puedo escribir en la memoria externa",
			// Toast.LENGTH_LONG).show();

		}

		String timeStamp = new SimpleDateFormat("ddMMyyyy_HHmmss")
				.format(new Date());

		// estudiar posibilidad de hallar auto el directotio
		final String inFileName = "/data/data/org.example.mislugares/databases/lugares";
		File dbFile = new File(inFileName);
		FileInputStream f = null;

		f = new FileInputStream(dbFile);

		File directorio = (Environment.getExternalStorageDirectory()); // obtenerDirectorioCopias();
		// File d = new File(directorio);
		// if (!d.exists()) {
		// d.mkdir();

		String outFileName = directorio + "/" + "lugares.db" + "_" + timeStamp;

		OutputStream output = new FileOutputStream(outFileName);

		byte[] buffer = new byte[1024];
		int length;
		while ((length = f.read(buffer)) > 0) {
			output.write(buffer, 0, length);
		}

		output.flush();
		output.close();
		f.close();

	}

}
